import Http from "../../utils/http"

export default class {
  execute(properties, target, component) {
    const form = target.closest("form")
    // Analogous to Rails' form_with's local
    if (form.dataset.local) {
      // This action works well with browser's native behaviour, e.g. pressing
      // ENTER on the keyboard will submit the form.
      form.submit()
    }
    else {
      const url = form.getAttribute("action")
      const formData = new FormData(form)
      const method = form.getAttribute("method")
      if (method.toUpperCase() === 'GET') {
        // const urlWithParams = Utils.url.appendParams(url, formData)
        // console.log(urlWithParams)
        
        const data = {
          url: Utils.url.appendParams(url, formData)
          // ,
          // formData: formData,
          // formDataEncoded: true
        }
        Utils.http.load(data, component)
      } else {
        const data = {
          url: url,
          formData: formData,
          formDataEncoded: true
        }
        Http.execute(data, method, component, (response) => Action.execute(response['onResponse'], target, component))
      }
    }
  }
}
